const int N = sizeof(unsigned) * 8;

#define rot(val, n) ((n) > 0 ? (val) << (n) | (val) >> (N - (n)) \
			    : (val) >> -(n) | (val) << ((N + (n)) & (N - 1)))

#include <iostream>
#include <bitset>

using namespace std;

int main()
{
	bitset<N> b;
	cin >> b;
	cout << endl;
	for (int i = 0; i < N; i++) {
		bitset<N> b1(rot(b, i)), b2(rot(b, -i));
		cout << b1 << "\t" << b2 << endl;
	}
	return 0;
}
