#include <stdio.h>

#ifdef __i386__
# define ATTRIB __attribute__((regparm(3)))
#else
# define ATTRIB
#endif

unsigned ATTRIB getipstr(char *);

int main(int argc, char *argv[])
{
	if (argc != 2) {
		fprintf(stderr, "Usage: %s <dotted-address>\n", argv[0]);
		return -1;
	}
	printf("%08X\n", getipstr(argv[1]));
	return 0;
}
