// Да се напише подпрограма, която да връща в регистри R1:R0 MAC-адреса,
// получен от низа тип ASCIIZ с начален адрес в регистър R0. Низът е в 16-ичен
// вид с разделител между байтовете препинателен знак, напр. 00-0C-76-1F-C5-EB

.global	getmacst
getmacst:
	MOV	R2,#0	// Започни начисто
L1:	MOV	R3,#0	// Нов текущ байт - започни натрупването от нулата
L2:	LDRB	R12,[R0],#1//Зареди поредния символ
	CMP	R12,#'0'// Цифра?
	BLO	L4	// Не, разделител или терминатор е - байтът е готов
	CMP	R12,#'9'
	SUBLS	R12,#'0'// Да, преобразувай от ASCII-код в тетрада битове
	BLS	L3
	BIC	R12,#'a'-'A'//Преобразувай евентуална малка буква в главна
	CMP	R12,#'A'// Главна буква?
	BLO	L4	// Не, разделител е - байтът е готов
	CMP	R12,#'F'
	SUBLS	R12,#'A'-10//Да, преобразувай от ASCII-код в тетрада битове
L3:	ADDLS	R3,R12,R3,LSL #4//Добави я към умножената по 16 текуща стойност
	BLS	L2	// Продължи със следващия символ от низа
L4:	MOV	R1,R1,LSL #8//Измести текущия адрес в R1:R2 с 1 байт наляво
	ORR	R1,R1,R2,LSR #24
	ORR	R2,R3,R2,LSL #8	//Запиши текущия байт отдясно
	CMP	R12,#0	// Край на низа?
	BNE	L1	// Не, продължи със следващия байт
	MOV	R0,R2	// Да, върни адреса в R1:R0
	BX	LR
