#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define SIZE	20

#ifdef __i386__
# define ATTRIB __attribute__((regparm(3)))
#else
# define ATTRIB
#endif

int ATTRIB search64(long long, size_t, long long *);

int main()
{
	long long a[SIZE], t;
	int i;

	setvbuf(stdout, NULL, _IONBF, 0);
	srand48(time(NULL));
	for (i = 0; i < SIZE; i++)
		a[i] = (unsigned)mrand48() | (long long)mrand48() << 32;
	for (i = 0; i < SIZE; i++)
		printf("%2d: %20lld\n", i, a[i]);
	printf("Search for? ");
	if (scanf("%lld", &t) == 1) {
		if ((i = search64(t, SIZE, a)) == -1)
			printf("Not found!\n");
		else
			printf("Found at index %d\n", i); 
	}
	return 0;
}
