/*
unsigned char *putVLQ(unsigned value, unsigned char *dest) // запиши ВПД
{				// (вж. Standard MIDI-File Format Spec. 1.1)
    unsigned buffer = value & 0x7f;
    while ((value >>= 7) > 0) {
	buffer <<= 8;
	buffer |= 0x80;
	buffer += value & 0x7f;
    }
    for ( ; ; ) {
	*dest++ = (unsigned char)buffer;
	if (buffer & 0x80)
	    buffer >>= 8;
	else
	    return dest;
    }
}
*/

.global	putvlq			// Регистри: value = R0, dest = R1, buffer = R2
putvlq:				//putVLQ(unsigned value, unsigned char *dest) {
	AND	R2,R0,#0x7F	//    unsigned buffer = value & 0x7f;
L1:	MOVS	R0,R0,LSR #7	//    while ((value >>= 7) > 0) {
	MOVNE	R2,R2,LSL #8	//	  buffer <<= 8;
	ORRNE	R2,R2,#0x80	//	  buffer |= 0x80;
	ANDNE	R3,R0,#0x7F	//	  buffer += value & 0x7f;
	ADDNE	R2,R2,R3	//   _}
	BNE	L1		//__/ for ( ; ; ) {
L2:	STRB	R2,[R1],#1	//	  *dest++ = (unsigned char)buffer;
	MOVS	R2,R2,LSR #8	//	  if (buffer & 0x80) buffer >>= 8;	      
	BCS	L2		//	  else return dest;
	MOV	R0,R1		//    }
	BX	LR		//}
