#include <stdio.h>

#ifdef __i386__
# define ATTRIB __attribute__((regparm(3)))
#else
# define ATTRIB
#endif

unsigned ATTRIB udiv64(unsigned long long a, unsigned b, unsigned *rem);

int main(void)	// http://ttmath.org/online_calculator
{
	unsigned long long dividend;
	unsigned divisor, quotient, remainder;
	int r1, r2;

	setvbuf(stdout, NULL, _IONBF, 0);
	printf("  Dividend: ");
	r1 = scanf("%llu", &dividend);
	printf("   Divisor: ");
	r2 = scanf("%u", &divisor);
	// > 18446744069414584319 / 4294967295
	if (dividend >> 32 >= divisor) {
		printf("Overflow!\n");
		return -1;
	}
	quotient = (unsigned)(dividend / divisor);
	remainder = (unsigned)(dividend % divisor);
	printf("\nC quotient: %u, remainder: %u", quotient, remainder);
	remainder = -1;
	quotient = udiv64(dividend, divisor, &remainder);
	printf("\n  Quotient: %u, remainder: %u\n", quotient, remainder);
	return r1 - r2;
}
